<template>
  <q-page class="sign-up row justify-center">
    <q-stepper class="col-6" color="primary" ref="stepper" alternative-labels>
      <q-step default name="first" title="Prihlasovacie údaje">
        <q-field
          label='Prezývka'
          :error="errors.has('username')"
          :error-label="errors.first('username')"
        >
          <q-input
            name="username"
            :error="errors.has('username')"
            v-model="user.username"
            v-validate="'required'"
            @focus="focus = true"
            @blur="focus = false"
          />
        </q-field>
        <q-field
          label='Email'
          :error="errors.has('email')"
          :error-label="errors.first('email')"
        >
          <q-input
            name="email"
            :error="errors.has('email')"
            v-model="user.email"
            v-validate="'required|email'"
            type="email"
            @focus="focus = true"
            @blur="focus = false"
          />
        </q-field>
        <q-field
          label='Heslo'
          :error="errors.has('password')"
          :error-label="errors.first('password')"
        >
          <q-input
            name="password"
            :error="errors.has('password')"
            v-model="user.password"
            v-validate="{ required: true, min: 8, regex: /^.*(?=.*[a-z])(?=.*[A-Z])(?=.*\d).*$/ }"
            type="password"
            @focus="focus = true"
            @blur="focus = false"
          />
        </q-field>
      </q-step>

      <q-step name="second" title="Bežec/Majiteľ" subtitle="">
        <div class="column justify-center items-center">
          <q-radio
            v-model="user.userType"
            val="runner"
            left-label
            label="Bežec"
          />
          <q-radio
            v-model="user.userType"
            val="owner"
            left-label
            label="Majiteľ"
          />
        </div>
      </q-step>
      <q-step name="third" title="Psíky" done-ico="checkmark">
        <DogForm
          v-for="(dog, index) in dogs" :key="index"
          v-model="dogs[index]"
          :action="() => { saveDog(index) }"
        />
      </q-step>
        <q-stepper-navigation>
          <q-btn color="secondary" flat @click="cancel" label="Zrušiť" />
          <q-btn color="primary" @click="nextStep" label="Ďalej" />
        </q-stepper-navigation>
    </q-stepper>
  </q-page>
</template>

<style lang="scss">
  .sign-up {
    .card {
      padding: 2rem;
      margin-top: 1rem;
    }

    .add-button {
      margin-top: 2rem;
    }
  }
</style>

<script>
import DogForm from 'src/components/DogForm'

export default {
  name: 'SignUpPage',

  components: {
    DogForm
  },

  $_veeValidate: {
    validator: 'new'
  },

  data () {
    return {
      focus: false,
      user: {
        username: null,
        email: null,
        password: null,
        userType: null
      },
      dogs: [
        {
          name: null,
          age: null,
          breed: null,
          availableTo: null,
          availableFrom: null
        }
      ]
    }
  },

  methods: {
    async submit () {
      try {
        await this.$store.dispatch('user/signUp', this.user)
      } catch (err) {
        console.error(err)
        this.$q.notify('Niekde nastala chyba')
      }
    },

    async cancel () {
      try {
        await this.$q.dialog({
          title: 'Ste si istý?',
          message: 'Vaše údaje budú stratené',
          ok: 'Áno',
          cancel: 'Nie'
        })
        this.$router.push('/')
      } catch (err) {

      }
    },

    async nextStep () {
      try {
        await this.$validator.validateAll()
        if (this.errors.any()) {
          this.$q.notify(this.errors.first())
        } else if (this.user.userType === 'runner') {
          await this.submit()
          this.$router.push('/formularova-stranka')
        } else if (this.$refs.stepper.currentStep.name === 'second') {
          await this.submit()
        } else if (this.$refs.stepper.currentStep.last) {
          this.$router.push('/formularova-stranka')
        } else {
          this.$refs.stepper.next()
        }
      } catch (err) {
        console.log(err)
      }
    },

    async saveDog (index) {
      const dogType = {
        name: null,
        age: null,
        breed: null,
        availableTo: null,
        availableFrom: null
      }

      try {
        await this.$store.dispatch('dogs/createDog', this.dogs[index])
        this.dogs.push(dogType)
      } catch (err) {
        console.log(err)
      }
    }
  }
}
</script>
